/*
** definizione e test della funzione che testa se un vettore di interi
** e' palindromo
*/

/*
** inclusione del file di intestazione della libreria standard
** che contiene definizioni di macro, costanti e dichiarazioni
** di funzioni e tipi funzionali alle varie operazioni di I/O
*/
#include <stdio.h>

/* definizione della costante simbolica per la dimensione del vettore */
#define DIM 6
 
/*
** funzione per l'acquisizione del contenuto di un vettore di interi
*/
void acqVettInt (int *vett, int dim)
 {
 /* variabile per la scansione del vettore */
 int cursore;
 
 /* scandisce il vettore acquisendone gli elementi */
 for (cursore=0; cursore <= dim-1; cursore++)
    {
    printf("\nvett[%d]? ", cursore);
    scanf("%d", &vett[cursore]);
    }
 }
 
/*
** funzione per la restituzionee del contenuto di un vettore di interi
*/
void resVettInt (int *vett, int dim)
 {
 /* variabile per la scansione del vettore */
 int cursore;

 /* scandisce il vettore visualizzandone gli elementi */ 
 for (cursore=0; cursore <= dim-1; cursore++)
	printf("\nvett[%d]: %d", cursore, vett[cursore]);
 }

/*
** definizione della funzione che testa se un vettore di interi e' palindromo
*/
int palindromoVett(int *vettore, int dim)
  {
  /* variabile per la scansione del vettore */
  int cursore; 

  /* verifica se ogni elemento, nella prima metà del vettore e' uguale al suo simmetrico
  ** rispetto all'elemento di mezzo */  
  for(cursore = 0; cursore <= (DIM/2 -1); cursore ++)
	  /* se non sono uguali termina con falso */
	  if (vettore[cursore] != vettore[DIM-cursore-1])
	    return(0);
	
  /* se riesce a terminare la scansione, termina con vero */ 	
  return(1);	
  }

/*
** test della funzione che decide se un vettore di interi
** e' palindromo
** 
*/
int main()
	{
    /* definizione del vettore */
	int test[DIM];
	
	/* accquisizione del contenuto del vettore */
	acqVettInt(test, DIM);
	
	/* testa il corretto funzionamento della funzione che decide
	** se un vettore di interi e' palindromo */
	if (palindromoVett(test, DIM))
	  printf("\nIl vettore e' palindromo");
    else
	  printf("\nIl vettore non e' palindromo");
 
	return(1);
	}

